# See the file "LICENSE" for the full license governing this code.

require 'tcell_agent/routes/table'
require 'tcell_agent/sensor_events/discovery'

module TCellAgent
  class Agent
    def self.get_database_discovery_identifier(database, schema, table, fields)
      [
        database,
        schema,
        table,
        fields.join(',')
      ].join(',').hash
    end

    def discover_database_fields(route_id, database, schema, table, fields)
      return if route_id.nil? || database.nil? || schema.nil? || table.nil? || fields.nil?

      query_hash = TCellAgent::Agent.get_database_discovery_identifier(database, schema, table, fields)

      return if @route_table.routes[route_id].database_queries_discovered.fetch(query_hash, false)

      @route_table.routes[route_id].database_queries_discovered[query_hash] = true
      event = TCellAgent::SensorEvents::DiscoveryEvent.new(route_id).for_database_fields(database, schema, table, fields)
      TCellAgent.send_event(event)
      # discovered_fields = fields.select { |field|
      #    @route_table.routes[route_id].database_queries_discoverd[database][schema][table][field].discovered != true
      # }
      # if (discovered_fields.length > 0)
      #  discovered_fields.each { |field|
      #  @route_table.routes[route_id].database[database][schema][table][field].discovered = true
      #  }
      #  event = (TCellAgent::SensorEvents::DiscoveryEvent.new(route_id)).for_database_fields(database, schema, table, fields)
      #  TCellAgent.send_event(event)
      # end
    end
  end
end
