module TCellAgent
  @@instance_lock = Mutex.new
  @@my_thread_agent = nil

  def self.thread_agent
    unless @@my_thread_agent
      @@instance_lock.synchronize do
        @@my_thread_agent ||= TCellAgent::Agent.new
      end
    end

    @@my_thread_agent
  end

  def self.thread_agent=(some_agent)
    @@instance_lock.synchronize do
      @@my_thread_agent = some_agent
    end
  end

  def self.send_event(event)
    thread_agent.queue_sensor_event(event)
  end

  def self.report_metrics(response_time, tcell_context)
    thread_agent.report_metrics(response_time, tcell_context)
  end

  def self.policy(policy_type)
    thread_agent.policies.fetch(policy_type, nil)
  end

  def self.discover_database_fields(route_id, database, schema, table, fields)
    thread_agent.discover_database_fields(route_id, database, schema, table, fields)
  end

  def self.safe_to_check_cmdi?
    thread_agent && thread_agent.safe_to_check_cmdi
  end

  def self.stop_agent
    thread_agent.stop_agent = true
  end
end
