class IO
  class << self
    if TCellAgent.configuration.should_instrument?('IO::binread')
      alias_method :tcell_original_binread, :binread
      def binread(*args, &block)
        TCellAgent::Instrumentation::Lfi.cmdi_open_handler(args)

        tcell_original_binread(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::binwrite')
      alias_method :tcell_original_binwrite, :binwrite
      def binwrite(*args, &block)
        TCellAgent::Instrumentation::Lfi.default_open_handler(args, 'Write')

        tcell_original_binwrite(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::foreach')
      alias_method :tcell_original_foreach, :foreach
      def foreach(*args, &block)
        TCellAgent::Instrumentation::Lfi.default_open_handler(args, 'Read')

        tcell_original_foreach(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::popen')
      alias_method :tcell_original_popen, :popen
      def popen(*args, &block)
        TCellAgent::Cmdi.popen_cmdi_handler(args)

        tcell_original_popen(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::read')
      alias_method :tcell_original_read, :read
      def read(*args, &block)
        TCellAgent::Instrumentation::Lfi.cmdi_open_handler(args, 'Read')

        tcell_original_read(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::readlines')
      alias_method :tcell_original_readlines, :readlines
      def readlines(*args, &block)
        TCellAgent::Instrumentation::Lfi.cmdi_open_handler(args, 'Read')

        tcell_original_readlines(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::sysopen')
      alias_method :tcell_original_sysopen, :sysopen
      def sysopen(*args, &block)
        TCellAgent::Instrumentation::Lfi.default_open_handler(args)

        tcell_original_sysopen(*args, &block)
      end
    end

    if TCellAgent.configuration.should_instrument?('IO::write')
      alias_method :tcell_original_write, :write
      def write(*args, &block)
        TCellAgent::Instrumentation::Lfi.default_open_handler(args, 'Write')

        tcell_original_write(*args, &block)
      end
    end
  end
end
