module Kernel
  private

  if TCellAgent.configuration.should_instrument?('Kernel#`')
    alias_method :tcell_original_backtick, :`
    def `(cmd)
      TCellAgent::Cmdi.raise_if_block(cmd)

      tcell_original_backtick(cmd)
    end

    module_function :`
  end

  if TCellAgent.configuration.should_instrument?('Kernel#exec')
    alias_method :tcell_original_exec, :exec
    def exec(*args)
      TCellAgent::Cmdi.default_cmdi_handler(args)

      tcell_original_exec(*args)
    end

    module_function :exec
  end

  if TCellAgent.configuration.should_instrument?('Kernel#gets')
    alias_method :tcell_original_gets, :gets
    def gets(*args, &block)
      TCellAgent::Instrumentation::Lfi.argf_open_handler

      tcell_original_gets(*args, &block)
    end

    module_function :gets
  end

  if TCellAgent.configuration.should_instrument?('Kernel#open')
    alias_method :tcell_original_open, :open
    def open(*args, &block)
      TCellAgent::Instrumentation::Lfi.cmdi_open_handler(args)

      tcell_original_open(*args, &block)
    end

    module_function :open
  end

  if TCellAgent.configuration.should_instrument?('Kernel#readline')
    alias_method :tcell_original_readline, :readline
    def readline(*args, &block)
      TCellAgent::Instrumentation::Lfi.argf_open_handler

      tcell_original_readline(*args, &block)
    end

    module_function :readline
  end

  if TCellAgent.configuration.should_instrument?('Kernel#spawn')
    alias_method :tcell_original_spawn, :spawn
    def spawn(*args)
      TCellAgent::Cmdi.default_cmdi_handler(args)

      tcell_original_spawn(*args)
    end

    module_function :spawn
  end

  if TCellAgent.configuration.should_instrument?('Kernel#system')
    alias_method :tcell_original_system, :system
    def system(*args)
      TCellAgent::Cmdi.default_cmdi_handler(args)

      tcell_original_system(*args)
    end

    module_function :system
  end
end
