require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class AppfirewallPolicy < Policy
      def self.api_identifier
        'appsensor'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['appfirewall'] || false
      end

      def check_appfirewall_injections(appsensor_meta)
        return unless @enabled

        TCellAgent::Instrumentation.safe_block('AppFirewall inspection') do
          @native_agent.apply_appfirewall(appsensor_meta)
        end
      end
    end
  end
end
