require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class CommandInjectionPolicy < Policy
      def self.api_identifier
        'cmdi'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['cmdi'] || false
      end

      def block_command?(command, tcell_context)
        return false unless @enabled && tcell_context

        response = @native_agent.apply_cmdi(
          command, tcell_context
        )

        !response['blocked'].nil? && response['blocked']
      end
    end
  end
end
