require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class HeadersPolicy < Policy
      def self.api_identifier
        'headers'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['headers'] || false
      end

      def get_headers(content_type, tcell_context)
        return [] unless @enabled

        response = @native_agent.get_headers(content_type, tcell_context)
        response['headers'] || []
      end
    end
  end
end
