require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class HttpRedirectPolicy < Policy
      def self.api_identifier
        'http-redirect'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['http_redirect'] || false
      end

      def check_redirect(redirect_url, from_domain, status_code, tcell_context)
        return redirect_url unless @enabled

        redirect_response = @native_agent.check_http_redirect(
          redirect_url, from_domain, status_code, tcell_context
        )

        return '/' if redirect_response['block']

        redirect_url
      end
    end
  end
end
