require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class JsAgentPolicy < Policy
      def self.api_identifier
        'jsagentinjection'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['jsagentinjection'] || false
      end

      def get_js_agent_script_tag(tcell_context)
        return nil unless @enabled

        response = @native_agent.get_js_agent_script_tag(
          tcell_context
        )
        response['script_tag']
      end
    end
  end
end
