require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class LocalFileInclusion < Policy
      def self.api_identifier
        'lfi'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['local_file_access'] || false
      end

      def block_file_access?(path, mode, tcell_context)
        return false unless @native_agent

        response = @native_agent.file_access_apply(
          path, mode, tcell_context
        )

        !response['blocked'].nil? && response['blocked']
      end
    end
  end
end
