require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class LoginPolicy < Policy
      def self.api_identifier
        'login'
      end

      attr_reader :login_success_enabled, :login_failed_enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @login_success_enabled = enablements['login_success_enabled'] || false
        @login_failed_enabled = enablements['login_failed_enabled'] || false
      end

      def report_login_success(user_id, headers, tcell_context)
        return {} unless @login_success_enabled

        success = true
        password = nil
        user_valid = true
        @native_agent.login_fraud_apply(
          success, user_id, password, headers, user_valid, tcell_context
        )
      end

      def report_login_failure(user_id,
                               password,
                               headers,
                               user_valid,
                               tcell_context)
        return {} unless @login_failed_enabled

        success = false
        @native_agent.login_fraud_apply(
          success, user_id, password, headers, user_valid, tcell_context
        )
      end
    end
  end
end
