require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class PatchesPolicy < Policy
      def self.api_identifier
        'patches'
      end

      attr_accessor :enabled

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @enabled = enablements['patches'] || false
      end

      def block_request?(appsensor_meta)
        return false unless @enabled

        quick_check_response = @native_agent.apply_suspicious_quick_check(appsensor_meta)

        if quick_check_response == 1
          response = @native_agent.apply_patches(appsensor_meta)
          return !response['apply_response'].nil? && response['apply_response']['status'] == 'Blocked'
        end

        quick_check_response == 2
      end
    end
  end
end
