require 'tcell_agent/policies/policy'

module TCellAgent
  module Policies
    class SystemEnablements < Policy
      def self.api_identifier
        'systemEnablement'
      end

      attr_accessor :send_routes_enabled,
                    :send_lfi_path_discovery

      def initialize(native_agent, enablements)
        @native_agent = native_agent
        @send_routes_enabled = true
        update_enablements(enablements)
      end

      def update_enablements(enablements)
        enablements ||= {}

        @send_routes_enabled = enablements['system_send_routes'] || true
        @send_lfi_path_discovery = enablements['send_lfi_path_discovery'] || true
      end
    end
  end
end
