require 'devise'
require 'devise/rails'
require 'devise/strategies/database_authenticatable'
require 'tcell_agent/rails/auth/userinfo'

module TCellAgent
  TCellAgent::UserInformation.class_eval do
    class << self
      alias_method :original_get_user_from_request, :get_user_from_request
      def get_user_from_request(request)
        orig_user_id = original_get_user_from_request(request)
        begin
          if request.session && request.session.key?('warden.user.user.key')
            userkey = request.session['warden.user.user.key']
            user_id = if userkey.length == 2
                        userkey[0][0]
                      else
                        userkey[1][0]
                      end
            return user_id.to_s if user_id.is_a? Integer
          end
        rescue StandardError
          return orig_user_id
        end
        orig_user_id
      end
    end
  end
end
