require 'tcell_agent/utils/strings'
require 'tcell_agent/instrumentation'

module TCellAgent
  module Utils
    module Rails
      def self.reverse_proxy_header(request)
        return unless TCellAgent.configuration.reverse_proxy

        TCellAgent::Instrumentation.safe_block('Extracting reverse proxy header') do
          reverse_proxy_header = TCellAgent.configuration.reverse_proxy_ip_address_header

          return if reverse_proxy_header.nil? || reverse_proxy_header.empty?

          return request.env["HTTP_#{reverse_proxy_header.upcase.tr('-', '_')}"]
        end
      end
    end
  end
end
