require 'tcell_agent/instrumentation'

module TCellAgent
  module CsrfExceptionReporter
    def handle_unverified_request
      TCellAgent::Instrumentation.safe_block('AppSensor CSRF Exception processing') do
        appfirewall_policy = TCellAgent.policy(TCellAgent::PolicyTypes::APPSENSOR)
        if appfirewall_policy.enabled
          tcell_data = request.env[TCellAgent::Instrumentation::TCELL_ID]
          if tcell_data
            tcell_data.csrf_exception_name = 'ActionController::InvalidAuthenticityToken'
          end
        end
      end

      super if defined?(super)
    end
  end
end
