# See the file "LICENSE" for the full license governing this code.

require 'rails'

require 'tcell_agent/rails/middleware/global_middleware'
require 'tcell_agent/rails/middleware/body_filter_middleware'
require 'tcell_agent/rails/middleware/headers_middleware'
require 'tcell_agent/rails/middleware/context_middleware'

require 'tcell_agent/rails/routes'
require 'tcell_agent/rails/settings_reporter'
require 'tcell_agent/rails/dlp'
require 'tcell_agent/rails/csrf_exception'

require 'cgi'
require 'thread'

module TCellAgent
  class TCellAgentStartupRailtie < Rails::Railtie
    initializer :tcell_insert_middleware, :before => :build_middleware_stack do |app|
      app.config.middleware.insert_before(0, TCellAgent::Instrumentation::Rails::Middleware::ContextMiddleware)
      app.config.middleware.insert_after(0, TCellAgent::Instrumentation::Rails::Middleware::HeadersMiddleware)
      app.config.middleware.use TCellAgent::Instrumentation::Rails::Middleware::BodyFilterMiddleware
      app.config.middleware.use TCellAgent::Instrumentation::Rails::Middleware::GlobalMiddleware
    end
  end

  class TCellAgentCSRFRailtie < Rails::Railtie
    initializer 'tcell.sensors' do |_app|
      ActiveSupport.on_load :action_controller do
        ActionController::Base.send(:include, TCellAgent::CsrfExceptionReporter)
      end
    end
  end
end
