module TCellAgent
  module Utils
    module Rails
      STATUSES_MISSING_CONTENT_LENGTH = Set.new((100..199).to_a + [204, 205, 304])

      def self.empty_content?(status_code, headers)
        STATUSES_MISSING_CONTENT_LENGTH.include?(status_code.to_i) ||
          (headers['Content-Length'] && headers['Content-Length'].to_i.zero?)
      end

      def self.processable_response?(response_headers)
        content_disposition = response_headers['Content-Disposition']
        is_attachment = content_disposition && content_disposition =~ /^attachment/i

        content_type = response_headers['Content-Type']
        applicable_content_type = content_type &&
                                  (content_type =~ %r{application/json}i ||
                                   content_type =~ %r{application/xml}i ||
                                   content_type =~ /^text/i)
        !is_attachment && applicable_content_type
      end
    end
  end
end
