module TCellAgent
  module Routes
    class FieldEndpoint
      attr_accessor :discovered

      def initialize
        super()
        @discovered = false
      end
    end

    class RouteEndpoint
      attr_accessor :database
      attr_accessor :database_queries_discovered

      def initialize
        @database_queries_discovered = {}
        @database = Hash.new do |d_h, d_k| # Database
          d_h[d_k] = Hash.new do |s_h, s_k| # Schema
            s_h[s_k] = Hash.new do |t_h, t_k| # Table
              t_h[t_k] = Hash.new do |f_h, f_k| # Field
                f_h[f_k] = FieldEndpoint.new
              end
            end
          end
        end
      end
    end

    class RouteTable
      attr_accessor :routes

      def initialize
        @routes = Hash.new { |h, k| h[k] = RouteEndpoint.new }
      end
    end
  end
end
