require 'tcell_agent/sensor_events/sensor'

module TCellAgent
  module SensorEvents
    class DiscoveryEvent < TCellSensorEvent
      DATABASE_TYPE = 'db'.freeze
      def initialize(route_id = nil)
        super('discovery')
        self['rid'] = route_id if route_id
      end

      def for_database(database, schema, table, field)
        self['type'] = 'db'
        self['db'] = database
        self['schema'] = schema
        self['table'] = table
        self['field'] = field
      end

      def for_database_fields(database, schema, table, fields)
        self['type'] = 'db'
        self['db'] = database
        self['schema'] = schema
        self['table'] = table
        self['fields'] = fields
        self
      end
    end
  end
end
