# See the file "LICENSE" for the full license governing this code.

require 'tcell_agent/sensor_events/util/sanitizer_utilities'
require 'uri'

module TCellAgent
  module SensorEvents
    class TCellSensorEvent < Hash
      attr_accessor :send, :flush, :ensure

      def initialize(event_type)
        @send = true
        @flush = false
        @ensure = false
        @timestamp = Time.now.to_i
        self['event_type'] = event_type
      end

      def calculate_offset(from_timestamp)
        self['offset'] = from_timestamp - @timestamp
      end

      def bucket_key
        nil
      end
    end
  end
end
