# See the file "LICENSE" for the full license governing this code.

require 'cgi'
require 'openssl'

module TCellAgent
  module SensorEvents
    module Util
      def self.jhash(str)
        str.each_char.reduce(0) do |result, char|
          [((result << 5) - result) + char.ord].pack('L').unpack('l').first
        end
      end

      def self.calculate_route_id(method, path)
        route_id = jhash("#{(method || '').downcase}|#{path}")
        route_id = route_id.to_s if route_id
        route_id
      end
    end
  end
end
