# frozen_string_literal: true

Rack::Handler::Puma.class_eval do
  class << self
    alias_method :tcell_original_config, :config
    def config(app, options = {})
      conf = tcell_original_config(app, options)

      if defined?(Puma::Server) && !Puma::Server.instance_methods.include?(:tcell_original_run)
        Puma::Server.class_eval do
          alias_method :tcell_original_run, :run

          if defined?(Gem::Version) &&
             defined?(Puma::Const::PUMA_VERSION) &&
             (Gem::Version.new(Puma::Const::PUMA_VERSION) >= Gem::Version.new('5.1.0'))
            def run(background = true, thread_name: 'server')
              TCellAgent.thread_agent.start('Puma')
              original_run(background, :thread_name => thread_name)
            end
          else
            def run(background = true)
              TCellAgent.thread_agent.start('Puma')

              tcell_original_run(background)
            end
          end
        end
      end

      conf
    end
  end
end
