# This file gets included when the web server is launched through
# `bundle exec rails s` command. The appropriate server will be
# launched through Rack::Server interface

Rails::Server.class_eval do
  alias_method :tcell_build_app, :build_app
  def build_app(app)
    require('tcell_agent/servers/rack_puma_handler') if defined?(Rack::Handler::Puma)
    require('tcell_agent/servers/unicorn') if defined?(Unicorn::HttpServer)
    require('tcell_agent/servers/webrick') if defined?(Rack::Handler::WEBrick)
    require('tcell_agent/servers/thin') if defined?(Thin::Server)

    if defined?(Puma::Server)
      Puma::Server.class_eval do
        alias_method :tcell_original_run, :run
        def run(background = true)
          TCellAgent.thread_agent.start('Puma')
          tcell_original_run(background)
        end
      end
    end

    tcell_build_app(app)
  end
end
